<?php
    include 'idp_config.php';
    include 'utils.php';
    
    error_reporting(E_ALL);
    date_default_timezone_set("UTC");
    
    if (( ! isset($_POST["login"])) && ( ! isset($_POST["password"]))) {
        header('HTTP/1.1 400 Bad Request', true, 400);
        exit;
    }
    
    session_start();
    
    if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) {
        print "SecureBlackbox extension NOT available";
        die;
    }
        
    try {
        if (!SBUtils\GetLicense()) {
          #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it in "sbb.license_key" php.ini directive or here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
          SBUtils\SetLicenseKey("<enter license key here>");
        }
    } catch (SBException $e) {
        print "<p style='color:red'>Setting SBB License Key failed with message: <br/>" . $e->getErrorMessage() . "</p>";
        die;
    }
    
    global $credentials;
    
    $login = $_POST["login"];
    $pass = $_POST["password"];
    $storedPass = $credentials[$login];
    
    if (strcmp($storedPass, $pass) == 0) {
        $_SESSION['loggedIn'] = true;
        $_SESSION['login'] = $login;
        
        $saml = $_SESSION['requestBody'];
        
        $ms = new TMemoryStream();
        $ms->Write($saml, strlen($saml));
        $ms->set_Position(0);
            
        $doc = new TElXMLDOMDocument();
        $doc->LoadFromStream($ms);
        
        ProcessRequest($doc, $_SESSION['login'], $_SESSION['requestState'], $spMetaList);
    } else {
        $finfo = new finfo(FILEINFO_MIME);
        header('Content-Type: ' . $finfo->file(LOGIN_FORM));
        header('Content-Length: ' . filesize(LOGIN_FORM));

        ob_clean();
        flush();
        readfile(LOGIN_FORM);
    }
?>