jQuery.noConflict();
(function ($) {

	$(document).ready(function () {
		
		if ($("#menu").length > 0) {
			$("#menu").InitTreeMenu();
			$("#menu ul li > span").bind("click", function () {
				$(this).parent().toggleClass("collapsed");
				$(this).parent().find("ul:first").slideToggle();
			});	
		} else {
			$( ".doc-menu nav" ).load( "toc_part.html", function( result ) {
				if (result) {
					$("#menu").InitTreeMenu();
					$("#menu ul li > span").bind("click", function () {
						$(this).parent().toggleClass("collapsed");
						$(this).parent().find("ul:first").slideToggle();
					});
				}
			});
		}
	});
	
	$.fn.InitTreeMenu = function () {
		console.log(window.location.pathname);
		var p = window.location.pathname.split( '/' );
		var cl = "";

		$(this).find("ul li > ul").hide();
		$(this).find("ul li").addClass("collapsed")
		
		if ($(".parentLink").length > 0)
			cl = $(".parentLink").attr("href");
		else if ($('.doc-article a.AlinkSmaller:first').length > 0 && $('.doc-article a.AlinkSmaller:first').attr('href').indexOf("#") == -1)
			cl = $('.doc-article a.AlinkSmaller:first').attr('href');
		else
			cl = p[p.length - 1];
			
		$("a[href='" + cl + "']").addClass("active");
		$("a[href='" + cl + "']").parents("ul, li, ul:not(#menu)").show();
		$("a[href='" + cl + "']").parents("li").removeClass("collapsed");
	}
	
})(jQuery);